<template lang="pug">
	button(:title="title" :class="[type, align]")
		slot
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
	props: {
		title: {
			type: String,
			default: null,
			required: false,
		},
		type: {
			type: String,
			default: 'primary',
			validator(value: string): boolean {
				return (['primary', 'accent', 'ghost'].indexOf(value) !== -1);
			},
		},
		align: {
			type: String,
			default: '',
			validator(value: string): boolean {
				return (['left', 'right', ''].indexOf(value) !== -1);
			},
		},
	},
});
</script>

<style lang="scss" scoped>
@import "@/assets/style/_colors.scss";

button {
	margin: 5px;
	padding: 0 12px;
	height: 40px;
	display: inline-block;
	font-size: 1em;
	border: none;
	border-radius: 2px;
	cursor: pointer;
	transition: background-color 200ms;
	&::-moz-focus-inner {
		border: 0;
	}
}

.primary {
	color: $primary-txt-color;
	background-color: $primary-bg-color;
	&:hover {
		background-color: $primary-bg-color-hover;
	}
	&:active {
		background-color: $primary-bg-color-active;
	}
}

.accent {
	color: $accent-txt-color;
	background-color: $accent-bg-color;
	&:hover {
		background-color: $accent-bg-color-hover;
	}
	&:active {
		background-color: $accent-bg-color-active;
	}
}

.ghost {
	color: rgba(12, 12, 13, 0.8);
	background-color: transparent;
	&:hover {
		background-color: rgba(12, 12, 13, 0.1);
	}
	&:active {
		background-color: rgba(12, 12, 13, 0.2);
	}
}

.left {
	float: left;
}

.right {
	float: right;
}
</style>
